#pragma once

#include "CVector.h"
#include "CPosition.h"
#include <windows.h>

class CArcBall;

class CGlutWindow
{
public:
	CGlutWindow(void);
	~CGlutWindow(void);

	enum {
		MBUTTON_LEFT   = 0x01, 
		MBUTTON_MIDDLE = 0x02,
		MBUTTON_RIGHT  = 0x04,
		KBUTTON_CTRL   = 0x08,
		KBUTTON_SHIFT  = 0x10
	};

	virtual void renderFrame();
	virtual void idle();
	virtual void resize(int width, int height);
	virtual void keyEvent(unsigned char key,int x,int y);
	virtual void mouseButtonEvent(int button, int state,int x,int y);
	virtual void mouseMoveEvent(int x,int y);
	virtual void renderGeometry();

protected:
	int m_nWidth, m_nHeight;
	double m_dFieldOfView;
	double m_dCenter, m_dRadius, m_dZoom;
	CArcBall* m_pArcBall;
	CPosition m_vecMouseDown;
	bool m_bDragging;
	bool m_bZooming;
	CVector m_vecCameraPosition;
	double m_dTranslateX, m_dTranslateY;
	int m_nMouseState;
	bool m_bStereoAnaglyph;
	double m_dStereoAngle;
	
	void initializeGL();

};



